LeetCode 全排列II (共5次优化!)

题目链接: https://leetcode-cn.com/problems/permutations-ii/

题目大意:
给定一个可包含重复数字的序列,返回所有不重复的全排列。

示例:
输入: [1,1,2]
输出:
[
[1,1,2],
[1,2,1],
[2,1,1]
]

看完题目的第一感觉,是一道搜索题,可以dfs递归排列出所有情况。
但是本题有一个附加条件: 输入的数字可重复,但是输出的结果不能重复。

思路一

在dfs输出全排列的情况下,加一个set,用于存储每一次排列拼接成的字符串,比如排列1是[1,1,2],拼接成的字符串是"1,1,2,",如果之后的排列拼接成的字符串在set中已存在,就不放入最终的结果集。

代码如下

class Solution {
 private int[] nums;

    // mark[i] = 0 表示nums[i]未使用,mark[i] = 1表示nums[i]已使用
    private int[] mark;

    private int length;

    // 存放每一次符合条件的排列
    private List<Integer> tempList;

    // 最终结果集
    private List<List<Integer>> resultList;

    private StringBuilder stringBuilder;
    
    private Set<String> set;

    public List<List<Integer>> permuteUnique(int[] nums) {
        length = nums.length;
        // 使用递归时,每一次递归都要创建栈,应尽量减少方法参数,因此定义成成员变量
        this.nums = nums;
        mark = new int[length];
        for (int i = 0; i < length; i++) {
            mark[i] = 0;
        }
        tempList = new ArrayList<>(length);
        resultList = new ArrayList<>();
        stringBuilder = new StringBuilder();
        set = new HashSet<>();

        dfsPermute(0);

        return resultList;
    }

     /**
      * index表示当前排列已经有多少元素
      */
    public void dfsPermute(int index) {
        if (index == length) {
            String str = stringBuilder.toString();
            if (!set.contains(str)) {
                // 没有重复,放入最终结果集
                resultList.add(new ArrayList<>(tempList));
                set.add(str);
            }
        }

        for (int i = 0; i < length; i++) {
            // 如果nums[i]未被使用,放入本次排列
            if (mark[i] == 0) {
                // 把nums[i]标记为已使用
                mark[i] = 1;
                // 将元素放入本次排列
                tempList.add(nums[i]);
                String tempStr = String.valueOf(nums[i]) + ",";
                // 拼接本次元素
                stringBuilder.append(tempStr);
                // 递归搜索
                dfsPermute(index + 1);
                // 把nums[i]标记为未使用
                mark[i] = 0;
                // 移除本次元素
                tempList.remove(tempList.size() - 1);
                // 移除本次元素,注意delete方法是左闭右开
                stringBuilder.delete(stringBuilder.length() - tempStr.length(), stringBuilder.length());
            }
        }
    }
}

第一个思路成功AC,但是耗时104ms太长了,继续优化。

思路二

第一个思路虽然可以AC,但是存在重复的搜索,以[1,1,2]为例,第一次搜索,以第一个1开头,找到了[1,1,2]、[1,2,1]这两种排列,第二次搜索,以第二个1开头,找到的还是[1,1,2]、[1,2,1]这两种排列。
显然,开头的数字,如果是一样的,搜索出的结果也是一样的,因此第二个思路就是对这种情况进行优化。

代码如下

class Solution {
    private int[] nums;

    // mark[i] = 0 表示nums[i]未使用,mark[i] = 1表示nums[i]已使用
    private int[] mark;

    private int length;

    private List<Integer> tempList;

    private List<List<Integer>> resultList;

    private StringBuilder stringBuilder;
    
    private Set<String> set;

    // 用于对每一次搜索开头的数字做去重
    private Set<Integer> numSet;

    public List<List<Integer>> permuteUnique(int[] nums) {
        length = nums.length;
        this.nums = nums;
        mark = new int[length];
        for (int i = 0; i < length; i++) {
            mark[i] = 0;
        }
        tempList = new ArrayList<>(length);
        resultList = new ArrayList<>();
        stringBuilder = new StringBuilder();
        set = new HashSet<>();
        numSet = new HashSet<>(length);

        dfsPermute(0);

        return resultList;
    }

    public void dfsPermute(int index) {
        if (index == length) {
            String str = stringBuilder.toString();
            if (!set.contains(str)) {
                resultList.add(new ArrayList<>(tempList));
                set.add(str);
                numSet.add(tempList.get(0));
            }
        }

        for (int i = 0; i < length; i++) {
            if (index == 0) {
                // 如果numSet中已经有本次搜索开始的第一个数字,continue
                if (numSet.contains(nums[i])) {
                    continue;
                } else {
                    numSet.add(nums[i]);
                }
            }
            if (mark[i] == 0) {
                mark[i] = 1;
                tempList.add(nums[i]);
                String tempStr = String.valueOf(nums[i]) + ",";
                stringBuilder.append(tempStr);
                dfsPermute(index + 1);
                mark[i] = 0;
                tempList.remove(tempList.size() - 1);
                // 左闭右开
                stringBuilder.delete(stringBuilder.length() - tempStr.length(), stringBuilder.length());
            }
        }
    }
}

第二个思路同样AC,耗时46ms,还是太慢,继续优化。

思路三

第二个思路依然存在重复的搜索,以[1,1,2]为例,比如一次搜索以2开头,如果以第一个1作为第二个元素,得到的结果是[2,1,1],如果以第二个1作为第二个元素,得到的结果还是[2,1,1]。
显然,不仅需要对搜索的第一个元素做去重,第2, 3, .... n 个元素都需要去重,这就是第三个思路。
注意: 第二个思路的numSet是成员变量,第三个思路的numSet是局部变量

代码如下

class Solution {
    private int[] nums;

    // mark[i] = 0 表示nums[i]未使用,mark[i] = 1表示nums[i]已使用
    private int[] mark;

    private int length;

    private List<Integer> tempList;

    private List<List<Integer>> resultList;

    private StringBuilder stringBuilder;
    
    private Set<String> set;

    public List<List<Integer>> permuteUnique(int[] nums) {
        length = nums.length;
        this.nums = nums;
        mark = new int[length];
        for (int i = 0; i < length; i++) {
            mark[i] = 0;
        }
        tempList = new ArrayList<>(length);
        resultList = new ArrayList<>();
        stringBuilder = new StringBuilder();
        set = new HashSet<>();

        dfsPermute(0);

        return resultList;
    }

    public void dfsPermute(int index) {
        if (index == length) {
            String str = stringBuilder.toString();
            if (!set.contains(str)) {
                resultList.add(new ArrayList<>(tempList));
                set.add(str);
            }
        }
        
        // 每次递归都会创建新的numSet,即对第1,2,3...n个元素,都做了去重
        Set<Integer> numSet = new HashSet<>(length);
        for (int i = 0; i < length; i++) {

            if (mark[i] == 0) {

                if (numSet.contains(nums[i])) {
                    continue;
                } else {
                    numSet.add(nums[i]);
                }

                mark[i] = 1;
                tempList.add(nums[i]);
                String tempStr = String.valueOf(nums[i]) + ",";
                stringBuilder.append(tempStr);
                dfsPermute(index + 1);
                mark[i] = 0;
                tempList.remove(tempList.size() - 1);
                // 左闭右开
                stringBuilder.delete(stringBuilder.length() - tempStr.length(), stringBuilder.length());
            }
        }
    }
}

第三个思路也AC了,耗时8ms,还是不够快,继续优化。

思路四

看了好几次代码,想看看哪些操作比较耗时,最后目光定位到了stringBuilder上,假设某个样例的输入数组nums长度是100,总共有1000个符合条件的排列,那么就要拼接100*1000=100000次,这绝对是个巨大的开销!!!
仔细想想,其实第三个思路,已经对第1,2,3...n个元素都做了去重,已经可以保证输出的结果不会重复,所以没有必要对每一个排列都拼接成字符串放进set做去重。
因此第四个思路,就是把stringBuilder去掉

代码如下

class Solution {
     private int[] nums;

    // mark[i] = 0 表示nums[i]未使用,mark[i] = 1表示nums[i]已使用
    private int[] mark;

    private int length;

    private List<Integer> tempList;

    private List<List<Integer>> resultList;

    private Set<String> set;

    public List<List<Integer>> permuteUnique(int[] nums) {
        length = nums.length;
        this.nums = nums;
        mark = new int[length];
        for (int i = 0; i < length; i++) {
            mark[i] = 0;
        }
        tempList = new ArrayList<>(length);
        resultList = new ArrayList<>();
        set = new HashSet<>();

        dfsPermute(0);

        return resultList;
    }

    public void dfsPermute(int index) {
        if (index == length) {
            resultList.add(new ArrayList<>(tempList));
        }

        Set<Integer> numSet = new HashSet<>(length);
        for (int i = 0; i < length; i++) {

            if (mark[i] == 0) {

                if (numSet.contains(nums[i])) {
                    continue;
                } else {
                    numSet.add(nums[i]);
                }

                mark[i] = 1;
                tempList.add(nums[i]);
                dfsPermute(index + 1);
                mark[i] = 0;
                tempList.remove(tempList.size() - 1);
            }
        }
    }
}

第四个思路也AC了,耗时4ms,继续优化。

思路五

继续看代码,寻找耗时的操作,最后目光定位到了numSet。
每一个递归,都要创建numSet,1000次递归,就要创建1000个numSet,这也是个不小的开销,有没有更简单的方法可以代替numSet,实现去重?
其实numSet的作用,遍历nums数组,找第n个元素时,把nums数组中重复的数字去掉。
如果先对nums数组从小到大排序,用一个Integer保存上一次的nums[i],那么如果nums[i+1]==nums[i],就表示nums[i+1]是重复的数字,只有nums[i+1]!=nums[i]的时候,才继续搜索。

代码如下

class Solution {
    private int[] nums;

    // mark[i] = 0 表示nums[i]未使用,mark[i] = 1表示nums[i]已使用
    private int[] mark;

    private int length;

    private List<Integer> tempList;

    private List<List<Integer>> resultList;

    private Set<String> set;

    public List<List<Integer>> permuteUnique(int[] nums) {
        length = nums.length;
        this.nums = nums;
        mark = new int[length];
        for (int i = 0; i < length; i++) {
            mark[i] = 0;
        }
        tempList = new ArrayList<>(length);
        resultList = new ArrayList<>();
        set = new HashSet<>();

        Arrays.sort(nums);

        dfsPermute(0);

        return resultList;
    }

    public void dfsPermute(int index) {
        if (index == length) {
            resultList.add(new ArrayList<>(tempList));
        }

        Integer temp = null;
        for (int i = 0; i < length; i++) {

            if (mark[i] == 0 ) {

                if (temp != null && nums[i] == temp) {
                    continue;
                } else {
                    temp = nums[i];
                }


                mark[i] = 1;
                tempList.add(nums[i]);
                dfsPermute(index + 1);
                mark[i] = 0;
                tempList.remove(tempList.size() - 1);
            }
        }
    }
}

第五个思路同样AC,耗时2ms。

五次优化的对照表如下

image.png
最后编辑于
©著作权归作者所有,转载或内容合作请联系作者
  • 序言:七十年代末,一起剥皮案震惊了整个滨河市,随后出现的几起案子,更是在滨河造成了极大的恐慌,老刑警刘岩,带你破解...
    沈念sama阅读 217,406评论 6 503
  • 序言:滨河连续发生了三起死亡事件,死亡现场离奇诡异,居然都是意外死亡,警方通过查阅死者的电脑和手机,发现死者居然都...
    沈念sama阅读 92,732评论 3 393
  • 文/潘晓璐 我一进店门,熙熙楼的掌柜王于贵愁眉苦脸地迎上来,“玉大人,你说我怎么就摊上这事。” “怎么了?”我有些...
    开封第一讲书人阅读 163,711评论 0 353
  • 文/不坏的土叔 我叫张陵,是天一观的道长。 经常有香客问我,道长,这世上最难降的妖魔是什么? 我笑而不...
    开封第一讲书人阅读 58,380评论 1 293
  • 正文 为了忘掉前任,我火速办了婚礼,结果婚礼上,老公的妹妹穿的比我还像新娘。我一直安慰自己,他们只是感情好,可当我...
    茶点故事阅读 67,432评论 6 392
  • 文/花漫 我一把揭开白布。 她就那样静静地躺着,像睡着了一般。 火红的嫁衣衬着肌肤如雪。 梳的纹丝不乱的头发上,一...
    开封第一讲书人阅读 51,301评论 1 301
  • 那天,我揣着相机与录音,去河边找鬼。 笑死,一个胖子当着我的面吹牛,可吹牛的内容都是我干的。 我是一名探鬼主播,决...
    沈念sama阅读 40,145评论 3 418
  • 文/苍兰香墨 我猛地睁开眼,长吁一口气:“原来是场噩梦啊……” “哼!你这毒妇竟也来了?” 一声冷哼从身侧响起,我...
    开封第一讲书人阅读 39,008评论 0 276
  • 序言:老挝万荣一对情侣失踪,失踪者是张志新(化名)和其女友刘颖,没想到半个月后,有当地人在树林里发现了一具尸体,经...
    沈念sama阅读 45,443评论 1 314
  • 正文 独居荒郊野岭守林人离奇死亡,尸身上长有42处带血的脓包…… 初始之章·张勋 以下内容为张勋视角 年9月15日...
    茶点故事阅读 37,649评论 3 334
  • 正文 我和宋清朗相恋三年,在试婚纱的时候发现自己被绿了。 大学时的朋友给我发了我未婚夫和他白月光在一起吃饭的照片。...
    茶点故事阅读 39,795评论 1 347
  • 序言:一个原本活蹦乱跳的男人离奇死亡,死状恐怖,灵堂内的尸体忽然破棺而出,到底是诈尸还是另有隐情,我是刑警宁泽,带...
    沈念sama阅读 35,501评论 5 345
  • 正文 年R本政府宣布,位于F岛的核电站,受9级特大地震影响,放射性物质发生泄漏。R本人自食恶果不足惜,却给世界环境...
    茶点故事阅读 41,119评论 3 328
  • 文/蒙蒙 一、第九天 我趴在偏房一处隐蔽的房顶上张望。 院中可真热闹,春花似锦、人声如沸。这庄子的主人今日做“春日...
    开封第一讲书人阅读 31,731评论 0 22
  • 文/苍兰香墨 我抬头看了看天上的太阳。三九已至,却和暖如春,着一层夹袄步出监牢的瞬间,已是汗流浃背。 一阵脚步声响...
    开封第一讲书人阅读 32,865评论 1 269
  • 我被黑心中介骗来泰国打工, 没想到刚下飞机就差点儿被人妖公主榨干…… 1. 我叫王不留,地道东北人。 一个月前我还...
    沈念sama阅读 47,899评论 2 370
  • 正文 我出身青楼,却偏偏与公主长得像,于是被迫代替她去往敌国和亲。 传闻我的和亲对象是个残疾皇子,可洞房花烛夜当晚...
    茶点故事阅读 44,724评论 2 354

推荐阅读更多精彩内容